#include <stdexcept> 
#include <iostream> 

template <typename T> 
class array 
{ 
  public: 
    T &operator[](int index) 
    { 
      if (index < 0 || index > 9) 
        throw std::runtime_error("Index ungueltig"); 
      return data[index]; 
    } 

  private: 
    T data[10]; 
}; 

template <> 
class array<float> 
{ 
  public: 
    float &operator[](int index) 
    { 
      if (index < 0 || index > 999) 
        throw std::runtime_error("Index ungueltig"); 
      return data[index]; 
    } 

  private: 
    float data[1000]; 
}; 

int main() 
{ 
  array<int> i; 
  i[0] = 1; 
  std::cout << i[0] << std::endl; 
  array<float> f; 
  f[999] = 1; 
  std::cout << f[999] << std::endl; 
} 